from flask import Flask, render_template, flash, \
            request, session, \
            redirect, url_for, logging

from flask_wtf import FlaskForm
from wtforms import StringField, TextAreaField, PasswordField, validators
from wtforms.validators import InputRequired

from main import app, session, db, setting

from flask_sqlalchemy import SQLAlchemy
from sqlalchemy.sql import text as SQLQuery

import datamodel
from datamodel import table

from flask_login import login_required

from models import WebLog

from datetime import datetime, timedelta


class chgpasswordclass(table):
    def __init__(self, where=''):
        table.__init__(self)

        self.title = 'Change Password'
        self.tablename='user'
        self.columns=[]


class ChangePasswordForm(FlaskForm):

    oldpassword = PasswordField("Old Password", [validators.required()])
    newpassword = PasswordField("New Password", [validators.required()])
    confirmpassword = PasswordField("Confirm Password", [validators.required()])


    def validate_on_submit(self):
        result = super(ChangePasswordForm, self).validate()
        if self.newpassword.data != self.confirmpassword.data:

            updlog = WebLog(timedate = datetime.now(),
                            action_taken = 'CHANGEPASSWORD',
                            action_page = str(request.url).rsplit('/', 1)[1],
                            upd_by = session['userid'],
                            action_sql = 'Password changed unsuccess, new password and confirm password is not same')
            db.session.add(updlog)
            db.session.commit()
            
            flash('New Password and Confirm Password is not same', 'danger')
            
            return -1
        else:
            return 1



@app.route('/chgpassword', methods=['GET', 'POST'])
@login_required
def chgpassword():
    if 'username' not in session:
        return redirect('/login')

    updlog = WebLog(timedate = datetime.now(),
                    action_taken = 'GET',
                    action_page = str(request.url).rsplit('/', 1)[1],
                    upd_by = session['userid'])
    db.session.add(updlog)
    db.session.commit()

    form = ChangePasswordForm(request.form)

    table = chgpasswordclass()
    ddata = None

    error = ''

    if request.method=='POST' and request.form['menubtn'].upper()=='SAVEEDIT':
        oldpassword = request.form['oldpassword']
        newpassword = request.form['newpassword']
        confirmpassword = request.form['confirmpassword']

        if form.validate_on_submit() > 0:

            if setting.dbtype.upper() == 'MSSQL':
                tblname = "[user]"
                mysysdate = "GETDATE() "
            else:
                tblname = "user"
                mysysdate = "SYSDATE() "
                
            strSQL = "SELECT userid, password FROM " + tblname + " " + \
                     "WHERE userid = '" + str(session['userid']) + "' "
            sql = SQLQuery(strSQL)
            row = db.session.execute(sql).fetchone()

            if row is not None:
                password = row['password']
                
                if row['password'] is None:
                    password = '123456'

            if password != oldpassword:

                updlog = WebLog(timedate = datetime.now(),
                                action_taken = 'CHANGEPASSWORD',
                                action_page = str(request.url).rsplit('/', 1)[1],
                                upd_by = session['userid'],
                                action_sql = 'Password changed unsuccess, old password is not correct')
                db.session.add(updlog)
                db.session.commit()
                
                error = "You entered old password is not correct"
            else:
                strSQL = "UPDATE " + tblname + " " + \
                         "SET password = '" + str(newpassword) + "' " + \
                         ", password_last_change = " + mysysdate + " " + \
                         "WHERE userid = '" + str(session['userid']) + "' "
                sql = SQLQuery(strSQL)
                db.session.execute(sql)
                db.session.commit()


                updlog = WebLog(timedate = datetime.now(),
                                action_taken = 'CHANGEPASSWORD',
                                action_page = str(request.url).rsplit('/', 1)[1],
                                upd_by = session['userid'],
                                action_sql = 'Password changed success')
                db.session.add(updlog)
                db.session.commit()
                

                flash('You password changed success', 'success')
                
    
    return render_template('chgpassword.html', form=form, table=table, menu='sc', error=error)


    

