# -*- coding: utf-8 -*-

from flask import request
from datetime import datetime

from main import session, setting

class dCol():
    def __init__(self, colname, datatype='STRING', description='', \
                     dataEntry='TEXT', value=None, dataOption=[], \
                     size='20', minvalue=None, maxvalue=None, \
                     defaultvalue=None, readonly=False):
        self.colname = colname
        self.value = value
        self.datatype = datatype
        self.description = description
        self.dataEntry = dataEntry
        self.dataOption = dataOption
        self.size = size
        self.minvalue = minvalue
        self.maxvalue = maxvalue
        self.defaultvalue = defaultvalue
        self.readonly = readonly




class table():    
    def __init__(self):
        self.tablename=''
        self.title=''
        self.strWhere=''
        self.strOrder=''
        self.columns=[]
        self.uniquekey=[]
        self.sql = ''
        self.upd = ''
        self.add = ''
        self.dbtype = setting.dbtype
        self.bind = None
        #self.allow_sort = True
        pass
    def addcol(self, *args, **kwargs):
        #self.columns.append(col(**kwargs))
        dcol = dCol(*args, **kwargs)
        self.columns.append(dcol)
        
        if len(self.uniquekey) == 0:
            self.uniquekey.append(dcol.colname)
##            print 'uniquekey: ' + dcol.colname
            
        self.sql = 'SELECT '
        selectcols = ''
        for xcol in self.columns:
            self.sql = self.sql + xcol.colname + ', '
            selectcols = selectcols + xcol.colname + ', '
        self.sql = self.sql[:-2]
        selectcols = selectcols[:-2]
        self.sql = self.sql + ' FROM ' + self.tablename + ' '

        if self.title.upper().find('LAST 100') >= 0:
            self.sql = self.sql + self.strWhere
        else:
            self.sql = self.sql + self.strWhere + self.strOrder

        self.upd = 'UPDATE ' + self.tablename + ' SET '

        self.add = 'INSERT INTO ' + self.tablename + \
                   '(' + selectcols + ') VALUES('

        if request.method == 'POST' and request.form['menubtn'].upper()=='SAVEEDIT':
                updWhere = ''
                for xcol in self.columns:
                    self.upd = self.upd + xcol.colname + " = '" + \
                                       request.form["txt" + xcol.description] + "'" + \
                                       ", "
                    if xcol.colname in self.uniquekey:
                        if updWhere == '':
                            updWhere = " WHERE " 
                        else:
                            updWhere = updWhere + " AND "
                        updWhere = updWhere + xcol.colname + "='" + request.form["txt" + xcol.description] + "' "
                        
                self.upd = self.upd[:-2]
                self.upd = self.upd + updWhere

        elif request.method == 'POST' and request.form['menubtn'].upper()=='SAVEADD':
                updWhere = ''
                for xcol in self.columns:
                    self.add = self.add + " '" + \
                                       request.form["txt" + xcol.description] + "'" + \
                                       ", "
                    if xcol.colname in self.uniquekey:
                        if updWhere == '':
                            updWhere = " WHERE " 
                        else:
                            updWhere = updWhere + " AND "
                        updWhere = updWhere + xcol.colname + "='" + request.form["txt" + xcol.description] + "' "
                        
                self.add = self.add[:-2] + ")"
                #self.upd = self.upd + updWhere

        else:
            self.upd = ''
            self.add = ''

            

    def getval(self, colname):
        for xcol in self.columns:
            if xcol.colname == colname:
                return xcol.value
        return None

    
    

        

		
		
		
		

class employee(table):  ###means class employee is a subclass of class table
    def __init__(self, where=""):
        table.__init__(self)

        self.title = "Employee"
        self.tablename='employee'
        #self.uniquekey = ['emp_id']
        self.strWhere = where
        self.strOrder = 'ORDER BY status, emp_id '

        self.addcol(colname='emp_id', datatype='STRING', description='SmockID**')
        self.addcol(colname='emp_name', datatype='STRING', description='Name**')
        self.addcol(colname='card_no', datatype='STRING', description='BadgeNo**')
        self.addcol(colname='sup_id', datatype='STRING', description='SupID')
        self.addcol(colname='department', datatype='STRING', description='Department')
        self.addcol(colname='shift', datatype='STRING', description='Shift')
        self.addcol(colname='email', datatype='STRING', description='eMail')
        self.addcol(colname='costcenter', datatype='STRING', description='Cost Center')

##        print 'strOrder: ' + self.strOrder
##        print 'strWhere: ' + self.strWhere
##        print 'sql: ' + self.sql
##        print 'upd: ' + self.upd
##        print 'add: ' + self.add
##        print 'uniquekey: ' + str(self.uniquekey)




class EmployeeDefault(table):
    def __init__(self, where=''):
        table.__init__(self)
        
        self.title = "SMOCK TESTING LIMIT"    
        self.tablename = 'employee'
        self.uniquekey=['emp_id']
        self.strWhere = where
        self.strOrder = " "

        self.addcol(colname='emp_id', datatype='STRING', description='EmpID**')
##        self.addcol(colname='smlo', datatype='STRING', description='Lowest Limit (Mohm)**', \
##                    dataEntry='NUMBER', minvalue='0.01', maxvalue='10', size='5')
##        self.addcol(colname='smhi', datatype='STRING', description='Highest Limit (Mohm)**', \
##                    dataEntry='NUMBER', minvalue='10', maxvalue='1000', size='5')


        self.addcol(colname='smlo', datatype='STRING', description='Lowest Limit (Mohm)**', \
                    dataEntry='NUMBER', size='5')
        self.addcol(colname='smhi', datatype='STRING', description='Highest Limit (Mohm)**', \
                    dataEntry='NUMBER', size='5')
        

##        print self.sql
		
		

class user(table):
    def __init__(self, where=''):
        table.__init__(self)
        
        self.title = "SYSTEM USER"

        #self.bind = 'localdb'
        #self.dbtype = 'MYSQL'

        if self.dbtype == 'MSSQL':
            tablename = '[user]'
        else:
            tablename = 'user'

        self.tablename = tablename
        self.uniquekey=['userid']
        self.strWhere = where
        self.strOrder = " "

        self.addcol(colname='userid', datatype='STRING', description='UserID**')
        self.addcol(colname='username', datatype='STRING', description='Name')
        self.addcol(colname='accessright', datatype='STRING', description='AccessRight', \
                        dataEntry='OPTION', \
                        dataOption=['USER', 'COORDINATOR', 'ADMIN'])
        self.addcol(colname='email', datatype='STRING', description='Email**')

##        print self.sql


class iTaskList(table):
    def __init__(self, where=''):
        table.__init__(self)
        
        self.title = "Task List"    
        self.tablename = 'itasklist'
        self.uniquekey=['taskname']
        self.strWhere = where
        self.strOrder = " "

        now = datetime.now()

        self.addcol(colname='taskname', description='Task Name**')
        self.addcol(colname='procname', description='Process**')

        if self.sql.upper().find('PASSWORDEXPIRYNOTIFY') >= 0:
            self.addcol(colname='dintervaltype', description='Interval Type', \
                        dataEntry='OPTION', \
                        dataOption=['DAY'])
        else:
            self.addcol(colname='dintervaltype', description='Interval Type', \
                        dataEntry='OPTION', \
                        dataOption=['DAY', 'HOUR', 'MINUTE', 'MONTH'])

        self.addcol(colname='dinterval', description='Interval Time**', \
                    dataEntry='NUMBER', minvalue='1', size='5')
        self.addcol(colname='taskstartdate', description='Start Date**', \
                    dataEntry='DATE', defaultvalue=now.strftime("%Y-%m-%d"))
        self.addcol(colname='taskstarttime', description='Start Time**', \
                    dataEntry='TIME', defaultvalue=now.strftime("%H:%M"))
        self.addcol(colname='lastrun', description='Last Run', dataEntry='HIDDEN')
        self.addcol(colname='lastrunresult', description='Last Run Result', dataEntry='HIDDEN')
        self.addcol(colname='nextrun', description='Next Run', dataEntry='HIDDEN')
        self.addcol(colname='dstatus', description='Status', \
                        dataEntry='OPTION', \
                        dataOption=['ENABLE', 'DISABLE'])
        self.addcol(colname='created_by', description='Created By', \
                    dataEntry='HIDDEN', defaultvalue=session['userid'])
        self.addcol(colname='created_date', description='Created Date', \
                    dataEntry='HIDDEN', defaultvalue=now.strftime("%Y-%m-%d %H:%M:%S"))
        

        print('self.sql' + str(self.sql))



class SmockTesting(table):
    def __init__(self, where=''):
        table.__init__(self)

        self.tablename='smockresult'
        self.columns=[]
        self.title = "Smock Testing"

class WebReportLog(table):
    def __init__(self, where=''):
        table.__init__(self)

        self.tablename='weblog'
        self.columns=[]
        self.title = "Web Reporting Log"

class EmailTesting(table):
    def __init__(self, where=''):
        table.__init__(self)

        self.tablename='email'
        self.columns=[]
        self.title = "Email Testing"

class smock100(table):
    def __init__(self, where=''):
        table.__init__(self)

        self.title = "Smock Testing - Last 100"
        self.tablename='smockresult'
        self.strWhere = where
        self.strOrder = "ORDER BY timedate DESC "
        self.columns=[]

        #self.bind = 'localdb'
        #self.dbtype = 'MYSQL'

        self.addcol('timedate', 'DATETIME', 'DateTime', 'DATE')
        self.addcol('cardno', 'STRING', 'BadgeNo')
        self.addcol('emp_id', 'STRING', 'SmockID')
        self.addcol('emp_name', 'STRING', 'Emp Name')
        self.addcol('result', 'STRING', 'Result')
        
        resistanceineng = "ifnull(concat(substr(cast(substr(cast(smval as char), 1, 2) as decimal)/10, 1, 3), 'E', floor(log10(smval))) , '0E0') as smval "
        #self.addcol(resistanceineng, 'STRING', 'Resistance(ohm)')
        self.addcol('smval', 'STRING', 'Resistance(ohm)')




if __name__ == '__main__':
    print 'datamodel class'
    employee=employee()
    user=user()
    print employee.sql
    #print user.accessrights.dataEntry
    #print user.accessrights
    print user.columns[2].colname
    print user.getval('accessright')
    



##    print employee.cardno.dataEntry
##    print 'cardno value:' + str(employee.cardno.value)
##    print employee.empid.value
##    #print user.
##
##    print employee.dataOption
##    print user.dataOption
##    print smock100.dataOption
    
