from main import db, login_manager
from flask import session
from datetime import datetime
from email_func import *


class User(db.Model):

    title = "SYSTEM USER"

    __tablename__ = 'user'
    
    userid = db.Column(db.String(15), primary_key=True)
    username = db.Column(db.String(45), index=False, unique=False, nullable=False)
    accessright = db.Column(db.String(45), index=False, unique=False, nullable=False)
    password = db.Column(db.String(45))
    screen = db.Column(db.String(1045))
    email = db.Column(db.String(255), index=True, unique=True, nullable=False)
    empid = db.Column(db.String(25), db.ForeignKey('employee.emp_id'))
    check_password_expired = db.Column(db.String(45))
    password_last_change = db.Column(db.DateTime)
    last_login = db.Column(db.DateTime)
    fail_login = db.Column(db.Integer)
    session_token = db.Column(db.String(40), index=True)

    @property
    def is_authenticated(self):
        return True

    @property
    def is_active(self):
        return True

    @property
    def is_anonymous(self):
        return False

    def get_id(self):
        try:
            return unicode(self.session_token)  # python 2
        except NameError:
            return str(self.session_token)  # python 3
    
    def __repr__(self):
        return '<User %r>' % (self.userid)



# Set up user_loader
@login_manager.user_loader
def load_user(session_token):
    user_session = User.query.filter_by(session_token=session_token).first()

    if user_session is None:
##        login_manager.login_message = 'We detected something unusual about a recent sign-in to the account ' + \
##                                      str(session['userid'])
        login_manager.login_message = None
        login_manager.login_message_category = "info"

        session.clear()
    else:
        login_manager.login_message = None
        
    return user_session


### we change plan, don't change user duplicate here
### Set up user_loader
##@login_manager.user_loader
##def load_user(session_token):
##    user_session = User.query.filter_by(session_token=session_token).first()
##
##    if user_session is None:
####        login_manager.login_message = 'We detected something unusual about a recent sign-in to the account ' + \
####                                      str(session['userid'])
##        login_manager.login_message = None
##        login_manager.login_message_category = "info"
##
##
##        # get userid from session before clear session
##        curUserID = session['userid']        
##
##        session.clear()
##
##
##        # after clear session only save to weblog
##        # and email notify for duplicate login
##        # to make sure can logout success
##        action_result = "Logout user [" + curUserID + "], " + \
##                        "duplicate login from other place"
##        updlog = WebLog(timedate = datetime.now(),
##                        action_taken = 'LOGOUT',
##                        upd_by = 'SYSTEM',
##                        action_sql = action_result)
##        db.session.add(updlog)
##        db.session.commit()
##
##
##        curUserInfo = User.query.filter_by(userid=curUserID).first()
##
##        emailsubject = "Security Alert: ESD account was signed in multiple place at the same time"
##        htmlheader = "<b>Multiple sign-in to your ESD account at the same time</b><br><br>"
##        htmlbody = "Your Smock ESD Repoting Account was just signed in multiple place at the same time. " + \
##                   "You're getting this email to make sure it was you."
##        
##        htmlbody = htmlheader + htmlbody
##
####        send_email(subject = emailsubject, \
####                   recipients = curUserInfo.email, \
####                   html_body=htmlbody)
##        
##    else:
##        login_manager.login_message = None
##        
##    return user_session


class Employee(db.Model):

    title = "Employee"

    __tablename__ = 'employee'
    
    emp_id = db.Column(db.String(45), primary_key=True)
    card_no = db.Column(db.String(45), index=True, unique=True, default='')
    emp_name = db.Column(db.String(80), default='')
    sup_id = db.Column(db.String(45))
    department = db.Column(db.String(45))
    esdtesting = db.Column(db.String(15))
    email = db.Column(db.String(80))
    shift = db.Column(db.String(45))
    dept_desc = db.Column(db.String(80))
    jobtitle = db.Column(db.String(80))
    sup_name = db.Column(db.String(80))
    wslo = db.Column(db.Float)
    wshi = db.Column(db.Float)
    shlo = db.Column(db.Float)
    shhi = db.Column(db.Float)
    smocktesting = db.Column(db.String(45))
    smlo = db.Column(db.Float)
    smhi = db.Column(db.Float)
    smesc01 = db.Column(db.String(15))
    smesc02 = db.Column(db.String(15))
    smfail01 = db.Column(db.String(15))
    smfail02 = db.Column(db.String(15))
    cclist = db.Column(db.String(415))
    ccfail01 = db.Column(db.String(415))
    smecs02freq = db.Column(db.Integer)
    smfail02freq = db.Column(db.Integer)
    status = db.Column(db.String(30))
    message = db.Column(db.String(145))
    stdate = db.Column(db.DateTime)
    endate = db.Column(db.DateTime)
    updstatus = db.Column(db.String(45))
    type = db.Column(db.String(45))
    costcenter = db.Column(db.String(45))
    acclevel = db.Column(db.String(45))
    

    def __repr__(self):
        return '<Employee %r>' % (self.emp_id)



class WebLog(db.Model):
    __tablename__ = 'weblog'

    id = db.Column(db.Integer, primary_key=True, autoincrement=True)
    timedate = db.Column(db.DateTime)
    action_taken = db.Column(db.String(150))
    action_page = db.Column(db.String(150))
    upd_by = db.Column(db.String(50))
    action_sql = db.Column(db.Text)
    previous_record = db.Column(db.Text)
    upload_file_path = db.Column(db.Text)


    def __repr__(self):
        return '<WebLog %r%r>' % (self.timedate, self.upd_by)
    
