from flask import Flask, render_template, flash, \
            request, session, \
            redirect, url_for, logging

from flask_wtf import FlaskForm
from wtforms import StringField, TextAreaField, PasswordField, validators
from wtforms.validators import InputRequired

from datetime import datetime, timedelta

from flask_sqlalchemy import SQLAlchemy
from sqlalchemy.sql import text as SQLQuery



class ResetForm(FlaskForm):
    username = StringField('Username', validators=[InputRequired()])


from main import app, session, db, setting

import keygenerator

from email_func import *


@app.route('/pwresetrq', methods=['GET', 'POST'])
def pwresetrq():
    form = ResetForm()
    if form.validate_on_submit():
        return 'Form Successfully Submitted'
    else:
        return render_template('pwresetrq.html', form=form)



@app.route('/chkreset', methods=['GET', 'POST'])
def chkreset():
    try:
        print 'chkreset'
        form = ResetForm()
        if form.validate_on_submit():
            #return 'Form Successfully Submitted'

            userid = request.form['username']
            
            myemail = chkUserEmail(userid)

            if myemail != 'NOTFOUND' \
               and myemail != 'NOEMAIL' \
               and myemail != 'ERROR':

                strSQL = "SELECT userid, timedate, reset_key, has_activated " + \
                         "FROM pwreset " + \
                         "WHERE userid = '" + userid + "' "
                #print strSQL

                sql = SQLQuery(strSQL)
                row = db.session.execute(sql).fetchone()

                if row is not None:
                    if row['has_activated'] == 'FALSE':
                        key = row['reset_key']

                        if setting.dbtype.upper() == 'MSSQL':
                            mySQL = "UPDATE pwreset " + \
                                "SET timedate = GETDATE() " + \
                                "WHERE userid = '" + userid + "' "
                        else:
                            mySQL = "UPDATE pwreset " + \
                                    "SET timedate = SYSDATE() " + \
                                    "WHERE userid = '" + userid + "' "
                    else:
                        key = keygenerator.make_key()

                        if setting.dbtype.upper() == 'MSSQL':
                            mySQL = "UPDATE pwreset " + \
                                "SET timedate = GETDATE(), " + \
                                "reset_key = '" + str(key) + "', " + \
                                "has_activated = 'FALSE' " + \
                                "WHERE userid = '" + userid + "' "
                        else:
                            mySQL = "UPDATE pwreset " + \
                                    "SET timedate = SYSDATE(), " + \
                                    "reset_key = '" + str(key) + "', " + \
                                    "has_activated = 'FALSE' " + \
                                    "WHERE userid = '" + userid + "' "
                else:
                    key = keygenerator.make_key()

                    mySQL = "INSERT INTO pwreset(userid, reset_key, timedate, has_activated) " + \
                            "VALUES('" + userid + "', " + \
                            "'" + str(key) + "', " + \
                            "GETDATE(), " + \
                            "'FALSE') "

                sql = SQLQuery(mySQL)
                db.session.execute(sql)
                db.session.commit()


                urllink = ""
                urllink = str(url_for("pwreset_get",  \
                                  id = (str(key)), \
                                  loginid = (str(userid)), \
                                  _external=True))
                print(urllink)

                #print('1')
                emailcontent = 'Your requested that the password for your ' + \
                               'account be reset. Please click the link below ' + \
                               'to reset your password: <br><br>' + \
                               "<a href='" + urllink + "'>" + \
                               urllink + \
                               "</a><br><br>" + \
                               "<b><i>Please make sure you open above link " + \
                               "in SciSanmina network. This link only work on " + \
                               "intranet</i></b>"
                
                send_email(subject = 'Password Reset Requested', \
                           recipients = myemail, \
                           html_body = emailcontent)
                #print('2')
                
                
                #flash("Reset password link already sent to " + myemail, 'info')                
                flash(userid + ", " + \
                      "Reset password link already sent to " + myemail + " . " + \
                      "check your email for a link to reset your password.  It expires in 24 hours!", "success")
                return render_template('pwresetrq.html', form=form)
            else:
                if myemail == 'NOTFOUND':
                    flash("UserID not found.", "danger")
                elif myemail == 'NOEMAIL':
                    flash("Your email was never registered.", "danger")
                
                return render_template('pwresetrq.html', form=form)
        else:
            return render_template('pwresetrq.html', form=form)
        
    except Exception as e:
        #print("chkreset: " + str(e))
        flash("chkreset: " + str(e), 'danger')
        return render_template('pwresetrq.html', form=form)



def chkUserEmail(userid):
    try:
        if setting.dbtype.upper() == 'MSSQL':
            tblName = '[user]'
        else:
            tblName = 'user'
            
        strSQL = "SELECT userid, username, email " + \
                 "FROM " + tblName + " " + \
                 "WHERE userid = '" + userid + "' "
        #print strSQL

        sql = SQLQuery(strSQL)
        row = db.session.execute(sql).fetchone()

        if row is not None:
            if row['email'] is None:
                return 'NOEMAIL'
            elif row['email'] == '':
                return 'NOEMAIL'
            else:
                return row['email']
        else:
            return 'NOTFOUND'
            
    except Exception as e:
        return 'ERROR'
        flash("chkUserEmail: " + str(e), "danger")




@app.route("/pwreset/<id>/<loginid>", methods=["GET"])
def pwreset_get(id, loginid):
    try:
        key = id
        userid = loginid

        print(str(key))
        print(str(loginid))

        form = ResetForm()
        
        strSQL = "SELECT userid, timedate, reset_key, has_activated " + \
                 "FROM pwreset " + \
                 "WHERE userid = '" + userid + "' "

        sql = SQLQuery(strSQL)
        row = db.session.execute(sql).fetchone()
        
        if row is not None:
            generated_maxtime = row['timedate'] + timedelta(hours=24)

            if row['has_activated'] == 'TRUE':
                flash("You already reset your password with the URL you are using. " + \
                      "If you need to reset your password again, please make a" + \
                      " new request here.", "danger")
            elif datetime.now() > generated_maxtime:
                flash("Your password reset link expired. " + \
                      "Please generate a new one here.", "danger")
            elif row['reset_key'] != key:
                flash("Your password reset link either expired or invalid. " + \
                      "Please generate a new one here.", "danger")
            else:
                #print('2')
                mySQL = "UPDATE pwreset " + \
                        "SET has_activated = 'TRUE' " + \
                        "WHERE reset_key = '" + key + "' " + \
                        "AND userid = '" + userid + "' "
                sql = SQLQuery(mySQL)
                db.session.execute(sql)
                db.session.commit()


                if setting.dbtype.upper() == 'MSSQL':
                    tblName = '[user]'
                    mysysdate = 'GETDATE() '
                else:
                    tblName = 'user'
                    mysysdate = 'SYSDATE() '

                mySQL = "UPDATE " + tblName + " " + \
                        "SET password = '123456' " + \
                        ", password_last_change = " + mysysdate + " " + \
                        "WHERE userid = '" + userid + "' "
                sql = SQLQuery(mySQL)
                db.session.execute(sql)
                db.session.commit()
                
                flash("Your password is reset to 123456. " + \
                      "Please change your password after login success", "success")
        else:
            flash("Your password reset link user not found. " + \
                  "Please contact your administrator.", "danger")
            
        #return render_template('pwresetrq.html', form=form)
        return redirect(url_for("pwresetrq"))
    
    except Exception as e:
        flash("pwreset_get: " + str(e), "danger")
        return redirect(url_for("chkreset"))
