from flask import Flask, render_template, request, redirect, url_for, \
     flash, session, logging, send_from_directory
from flask_sqlalchemy import SQLAlchemy
from sqlalchemy.sql import text as SQLQuery
from wtforms import Form, StringField, TextAreaField, PasswordField, validators

from main import app, session, db


# Register Form Class
class RegisterForm(Form):
    name = StringField('Name', [validators.Length(min=1, max=50)])
    username = StringField('Username', [validators.Length(min=1, max=25)])
    email = StringField('Email', [validators.Length(min=6, max=50)])
    password = PasswordField('Password', [
        validators.DataRequired(),
        validators.EqualTo('confirm', message='Password do not match')
    ])
    confirm = PasswordField('Confirm Password')


# User Register
@app.route('/register', methods=['GET', 'POST'])
def register():
    form = RegisterForm(request.form)
    if request.method == 'POST' and form.validate():
        name = form.name.data
        email = form.email.data
        username = form.username.data
        #password = sha256_crypt.encrypt(str(form.password.data))
        password = form.password.data

        # Execute query
        querystring = "INSERT INTO users(name, email, username, password) " + \
                      "VALUES('" + name + "', '" + email + "', '" + username + "', '" + password + "') "
        sql = SQLQuery(querystring)
        db.session.execute(sql)
        db.session.commit()

        flash('You are now registered and can log in', 'success')
        
        return redirect(url_for('login'))
        
    return render_template('register.html', form=form)
