from flask import Flask, render_template, flash, \
            request, session, \
            redirect, url_for, logging, send_file

from flask_wtf import FlaskForm
from wtforms import StringField, TextAreaField, PasswordField, validators
from wtforms.validators import InputRequired

import time

from flask_sqlalchemy import SQLAlchemy
from sqlalchemy.sql import text as SQLQuery

from main import app, session, db, setting

import datamodel

import pandas as pd
from io import BytesIO


from flask_login import login_required

from datetime import datetime

# for weblog ##########################################
from models import WebLog

global currData
currData = ''
#######################################################


def doDelete():
    for dlist in dlists:
        print dlist
        print 'DELETING'
        if request.url.upper().find('EMPLOYEE') > 0:
            strSQL = "DELETE FROM employee WHERE emp_id = '" + dlist + "' "
        elif request.url.upper().find('USER') > 0:
            if setting.dbtype.upper() == 'MSSQL':
                tblname = '[user]'
            else:
                tblname = 'user'
            strSQL = "DELETE FROM " + tblname + " WHERE userid = '" + dlist + "' "
        elif request.url.upper().find('ITASKLIST') > 0:
            strSQL = "DELETE FROM itasklist WHERE taskname = '" + dlist + "' "

        sql = SQLQuery(strSQL)
        db.session.execute(sql)
        db.session.commit()
        
        print 'SUCCESS DELETE'


##        print("save to weblog start")
        updlog = WebLog(timedate = datetime.now(),
                        action_taken = 'DELETE',
                        action_page = str(request.url).rsplit('/', 1)[1],
                        upd_by = session['userid'],
                        action_sql = strSQL)
        db.session.add(updlog)
        db.session.commit()
##        print("save to weblog done")
        
        
    return redirect(request.url)



def doResetPassword():
    strSQL = "UPDATE user " + \
             "SET password = '123456' " + \
             "WHERE userid = '" + str(request.form['txtUserID']) + "' "
    sql = SQLQuery(strSQL)
    db.session.execute(sql)
    db.session.commit()

    print 'SUCCESS RESET PASSWORD'

    return redirect(request.url)
    


@app.route('/tblshow/<sql>')
@app.route('/tblshow', methods=['GET', 'POST'])
@app.route('/uploadlist', methods=['GET', 'POST'])
@app.route('/employee', methods=['GET', 'POST'])
@app.route('/user', methods=['GET', 'POST'])
@app.route('/smock100', methods=['GET', 'POST'])
@app.route('/itasklist', methods=['GET', 'POST'])
@app.route('/employeedefault', methods=['GET', 'POST'])
@login_required
def tblshow(sql=None, menu='dea'):
    if 'username' not in session:
        return redirect('/login')


    ####################################################################
    # once come to page to refresh then save to log
    # for we easier to track for user login duplicate
    updlog = WebLog(timedate = datetime.now(),
                    action_taken = 'GET',
                    action_page = str(request.url).rsplit('/', 1)[1],
                    upd_by = session['userid'])
    db.session.add(updlog)
    db.session.commit()
    ####################################################################
    

    if request.method == 'POST':
        print 'requested url: ' + request.url
        print 'requested btn: ' + request.form['menubtn']
        global dlists
        dlists = request.form.getlist('check')
        
        if request.form['menubtn'].upper() =='DELETE':
            doDelete()

        if request.form['menubtn'].upper() =='RESETPASSWORD':
            doResetPassword()
                
    
    if request.url.find('employee')>0:
        sql = 'employee'

    if request.url.upper().find('EMPLOYEEDEFAULT')>0:
        sql = 'employeedefault'

    if request.url.find('uploadlist')>0:
        sql = 'upemployee'

    if request.url.upper().find('USER')>0:
        #print '******************'
        #print 'user'
        sql = 'user'

    if request.url.upper().find('SMOCK100')>0:
        sql = 'smock100'

    if request.url.upper().find('ITASKLIST')>0:
        sql = 'itasklist'



    global currData
    
    
    if sql != None:
        strWhere = ''
        if sql == 'employee':

            if request.method=='POST' and request.form['menubtn'].upper() == 'EDIT':
                if dlists == []:
                    pass
                    #return 'Nothing to Edit'
                else:
                    strWhere = "WHERE emp_id = '" + dlists[0] + "'"
                    
            elif request.method=='POST' and request.form['menubtn'].upper() == 'ADD':
                strWhere = "WHERE emp_id = 'xxxzzz' "
            elif request.method=='POST' and request.form['menubtn'].upper() == 'SEARCH':
                strWhere = "WHERE emp_id <> 'DEFAULT' "
                #print("txtSearch: " + str(request.form['txtSearch']))
                strSearch = request.form['txtSearch'].replace("'", "''")
                if strSearch != "":
                    strWhere = strWhere + \
                               "AND (UPPER(emp_id) LIKE '%" + strSearch + "%' " + \
                               "    OR UPPER(emp_name) LIKE '%" + strSearch + "%' " + \
                               "    OR UPPER(card_no) LIKE '%" + strSearch + "%' " + \
                               "    OR UPPER(sup_id) LIKE '%" + strSearch + "%' " + \
                               "    OR UPPER(department) LIKE '%" + strSearch + "%' " + \
                               "    OR UPPER(shift) LIKE '%" + strSearch + "%' " + \
                               "    OR UPPER(email) LIKE '%" + strSearch + "%' " + \
                               "    OR UPPER(costcenter) LIKE '%" + strSearch + "%' " + \
                               ") "
                    
            else:
                strWhere = "WHERE emp_id <> 'DEFAULT' "
                
            title = "Employee List"

            table = datamodel.employee(where=strWhere)
            menu = "sxeda"

        elif sql == 'upemployee':
            table = datamodel.employee(where='')
            menu = ""

        elif sql == 'employeedefault':
            strWhere = "WHERE upper(emp_id) = 'DEFAULT' "

            if request.method=='POST' and request.form['menubtn'].upper() == 'EDIT':
                if dlists == []:
                    pass
                    #return 'Nothing to Edit'
                else:
                    strWhere = "WHERE emp_id = '" + dlists[0] + "'"
            else:
                strWhere = "WHERE upper(emp_id) = 'DEFAULT' "
                

            table = datamodel.EmployeeDefault(where=strWhere)
            menu = "e"

        elif sql == 'user':
            strWhere = "WHERE userid <> 'idasuperuser' "
            if request.method=='POST' and request.form['menubtn'].upper() == 'EDIT':
                if dlists == []:
                    pass
                    #return 'Nothing to Edit'
                else:
                    strWhere = "WHERE userid = '" + dlists[0] + "'"
                    
            elif request.method=='POST' and request.form['menubtn'].upper() == 'ADD':
                strWhere = "WHERE userid = 'xxxzzz' "
            else:
                strWhere = "WHERE userid <> 'idasuperuser' "
                
            table = datamodel.user(where=strWhere)
                
        elif sql == 'smock100':
            table = datamodel.smock100()
            menu = "x"

        elif sql == "turnstile":
            pass

        elif sql == 'itasklist':

            if request.method=='POST' and request.form['menubtn'].upper() == 'EDIT':
                if dlists == []:
                    pass
                else:
                    strWhere = "WHERE taskname = '" + dlists[0] + "'"
                    
            elif request.method=='POST' and request.form['menubtn'].upper() == 'ADD':
                strWhere = "WHERE taskname = 'xxxzzz' "
            else:
                strWhere = ""
                
            title = "Task List"

            table = datamodel.iTaskList(where=strWhere)
            menu = "eda"



        ####################################################
        #kk, ddata = dbaccess.opentbl(sql)
        if request.method=='POST' and request.form['menubtn'].upper()=='SAVEEDIT':
            sql = SQLQuery(table.upd)
            db.session.execute(sql)
            db.session.commit()

##            print("save to weblog start")
            updlog = WebLog(timedate = datetime.now(),
                            action_taken = 'MODIFY',
                            action_page = str(request.url).rsplit('/', 1)[1],
                            upd_by = session['userid'],
                            previous_record = currData,
                            action_sql = table.upd)
            db.session.add(updlog)
            db.session.commit()
##            print("save to weblog done")
            
            
        elif request.method=='POST' and request.form['menubtn'].upper()=='SAVEADD':
            sql = SQLQuery(table.add)
            db.session.execute(sql)
            db.session.commit()

##            print("save to weblog start")
            updlog = WebLog(timedate = datetime.now(),
                            action_taken = 'CREATE',
                            action_page = str(request.url).rsplit('/', 1)[1],
                            upd_by = session['userid'],
                            action_sql = table.add)
            db.session.add(updlog)
            db.session.commit()
##            print("save to weblog done")
            

        if sql == 'smock100':
            if table.dbtype.upper() == 'MSSQL':
                table.sql = "SELECT TOP 100 * FROM ( " + table.sql + ")tbl1 " + \
                            "ORDER BY timedate DESC "
            else:
                table.sql = "SELECT * FROM ( " + table.sql + " ORDER BY timedate DESC )tbl1 " + \
                            "LIMIT 100 "
        print(table.sql)
        sql = SQLQuery(table.sql)
        ddata = db.session.execute(sql, bind=db.get_engine(app, table.bind)).fetchall()
    else:
        if table.dbtype.upper() == 'MSSQL':
            table.sql = "SELECT TOP 100 timedate as DateTime, " + \
                        "emp_id as EmpId, emp_name as Name, dept_id as Dept, result " + \
                        "FROM esdresult " + \
                        "ORDER BY timedate DESC "
        else:
            table.sql = "SELECT timedate as DateTime, " + \
                        "emp_id as EmpId, emp_name as Name, dept_id as Dept, result " + \
                        "FROM esdresult " + \
                        "ORDER BY timedate DESC " + \
                        "LIMIT 100"
        sql = SQLQuery(table.sql)
        ddata = db.session.execute(sql).fetchall()


    #ddata = dbaccess.emplist()
    if ddata == None:
        flash('Nothing to Show!!!', 'info')
        return render_template('tblshow.html', data=ddata, table=table, k=kk, menu=menu)
    elif request.method=='POST' and request.form['menubtn'].upper() =='EXCEL':
        if table.columns > 0:
            cdata = []
            for column in table.columns:
                if column.description.find('**') >= 0:
                    column.description = column.description[:-2]
                cdata.append(column.description)
                #print cdata
                
            df = pd.DataFrame(ddata, columns=cdata)
            output = BytesIO()
            writer = pd.ExcelWriter(output, engine='xlsxwriter')

            df.to_excel(writer, index=False)
            workbook  = writer.book
            writer.close()
            
            output.seek(0)


        updlog = WebLog(timedate = datetime.now(),
                        action_taken = 'EXPORT',
                        action_page = str(request.url).rsplit('/', 1)[1],
                        upd_by = session['userid'],
                        action_sql = table.sql)
        db.session.add(updlog)
        db.session.commit()
        

        return send_file(output, attachment_filename="Report.xlsx", as_attachment=True)
    
    elif request.method=='POST' and request.form['menubtn'].upper()=='EDIT':
        if dlists == []:
            flash('Nothing to Edit', 'info')
            return render_template('tblshow.html', data=ddata, table=table, menu=menu)
        else:
            if sql == 'user':
                menu = 'rsc'
            else:
                menu = 'sc'


            currData = ''
            for row in ddata:
                for column in table.columns:
                    currData = currData + \
                               column.colname + " = " + str(row[column.colname]) + "<br>"

##            print(currData)
            
            return render_template('tbledit.html', data=ddata, table=table, menu=menu)

    elif request.method=='POST' and request.form['menubtn'].upper()=='ADD':
        return render_template('tbledit.html', data=ddata, table=table, menu='ac')
    else:
        return render_template('tblshow.html', data=ddata, table=table, menu=menu)




if __name__ == '__main__':
    print "This is a test in tblShow"
    excel.init_excel(app)
    app.run(host='0.0.0.0', \
            port=8056, \
            debug=True, \
            threaded=True)
